program test1;

(*********************************************************************
 *
 * This programs gets the versions of the driver and the firmware of
 * the first U12 device using the libljacklm library.
 *
 * kms
 * march 2016
 *
 *********************************************************************)

uses
  ctypes;

const
{$IFDEF MSWINDOWS}
  libljacklmName = 'libljacklm.dll';
{$ENDIF MSWINDOWS}
{$IFDEF LINUX}
  libljacklmName = 'libljacklm.so.0';
{$ENDIF LINUX}
{$IFDEF DARWIN}
  libljacklmName = 'libljacklm.dylib';
  {$linklib libljacklm}
{$ENDIF DARWIN}

var
  idnum: clong;

function GetDriverVersion: cfloat;
         cdecl; external libljacklmName;
         
function GetFirmwareVersion(var idnum: clong): cfloat;
         cdecl; external libljacklmName;

begin
  writeln ('Getting library version.');
  writeln ('Version: ', GetDriverVersion:7:4);
  writeln ('Getting firmware version.');
  idnum := -1; // -1 means take the first device  
  writeln ('Version: ', GetFirmwareVersion(idnum):7:4);
end.