program test2;

(*********************************************************************
 *
 * This programs gets the version of the library and counts the 
 * devices of all labjack types using the liblabjackusb library.
 *
 * kms
 * march 2016
 *
 *********************************************************************)

uses
  ctypes;

const
{$IFDEF MSWINDOWS}
  liblabjackusbName = 'liblabjackusb.dll';
{$ENDIF MSWINDOWS}
{$IFDEF LINUX}
  liblabjackusbName = 'liblabjackusb.so.0';
{$ENDIF LINUX}
{$IFDEF DARWIN}
  liblabjackusbName = 'liblabjackusb.dylib';
  {$linklib liblabjackusb}
{$ENDIF DARWIN}

const 
//Product IDs
  UE9_PRODUCT_ID    = 9;
  U3_PRODUCT_ID     = 3;
  U6_PRODUCT_ID     = 6;
  U12_PRODUCT_ID    = 1;
  BRIDGE_PRODUCT_ID = 1000;
  T7_PRODUCT_ID     = 7;
  DIGIT_PRODUCT_ID  = 200;
  UNUSED_PRODUCT_ID = -1;

var
  version: real;
  count: integer;

function LJUSB_GetLibraryVersion: cfloat;
         cdecl; external liblabjackusbName;

function LJUSB_GetDevCount(ProductID: cint): cint;
         cdecl; external liblabjackusbName;

begin
  writeln ('+-------------------------------------------+');
  writeln ('| Checking the basic liblabjackusb library. |');
  writeln ('+-------------------------------------------+');
  version := LJUSB_GetLibraryVersion;
  writeln ('Version: ', version:7:4);
  count := LJUSB_GetDevCount (U3_PRODUCT_ID);
  writeln ('Found ', count, ' U3 devices.');
  count := LJUSB_GetDevCount (U6_PRODUCT_ID);
  writeln ('Found ', count, ' U6 devices.');
  count := LJUSB_GetDevCount (UE9_PRODUCT_ID);
  writeln ('Found ', count, ' UE9 devices.');
  count := LJUSB_GetDevCount (U12_PRODUCT_ID);
  writeln ('Found ', count, ' U12 devices.');
  count := LJUSB_GetDevCount (T7_PRODUCT_ID);
  writeln ('Found ', count, ' T7 devices.');
  count := LJUSB_GetDevCount (BRIDGE_PRODUCT_ID);
  writeln ('Found ', count, ' bridge devices.');
  count := LJUSB_GetDevCount (DIGIT_PRODUCT_ID);
  writeln ('Found ', count, ' digit devices.');
  writeln ('+----------------------------------------------------+');
  writeln ('| Finished checking the basic liblabjackusb library. |');
  writeln ('+----------------------------------------------------+');
end.